1 # SPDX-License-Identifier: GPL-2.0
3 # kbuild: Generic definitions
10 space := $(empty) $(empty)
11 space_escape := _-_SPACE_-_
15 # Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
16 dot-target = $(dir $@).$(notdir $@)
19 # The temporary file to save gcc -MMD generated dependencies must not
21 depfile = $(subst $(comma),_,$(dot-target).d)
24 # filename of target with directory and extension stripped
25 basetarget = $(basename $(notdir $@))
28 # real prerequisites without phony targets
29 real-prereqs = $(filter-out $(PHONY), $^)
32 # Escape single quote for use in echo statements
33 escsq = $(subst $(squote),'\$(squote)',$1)
36 # Quote a string to pass it to C files. foo => '"foo"'
37 stringify = $(squote)$(quote)$1$(quote)$(squote)
40 # Easy method for doing a status message
44 kecho := $($(quiet)kecho)
47 # filechk is used to check if the content of a generated file is updated.
50 # filechk_sample = echo $(KERNELRELEASE)
52 # $(call filechk,sample)
54 # The rule defined shall write to stdout the content of the new file.
55 # The existing file will be compared with the new one.
56 # - If no file exist it is created
57 # - If the content differ the new file is used
58 # - If they are equal no change, and no timestamp update
59 # - stdin is piped in from the first prerequisite ($<) so one has
60 # to specify a valid file as first prerequisite (often the kbuild file)
64 trap "rm -f $(dot-target).tmp" EXIT; \
65 { $(filechk_$(1)); } > $(dot-target).tmp; \
66 if [ ! -r $@ ] || ! cmp -s $@ $(dot-target).tmp; then \
68 mv -f $(dot-target).tmp $@; \
73 # gcc support functions
74 # See documentation in Documentation/kbuild/makefiles.rst
77 # Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
78 # Return first <prefix> where a <prefix>gcc is found in PATH.
79 # If no gcc found in PATH with listed prefixes return nothing
81 # Note: '2>/dev/null' is here to force Make to invoke a shell. Otherwise, it
82 # would try to directly execute the shell builtin 'command'. This workaround
83 # should be kept for a long time since this issue was fixed only after the
84 # GNU Make 4.2.1 release.
85 cc-cross-prefix = $(firstword $(foreach c, $(1), \
86 $(if $(shell command -v -- $(c)gcc 2>/dev/null), $(c))))
88 # output directory for tests below
89 TMPOUT = $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_$$$$
92 # Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
93 # Exit code chooses option. "$$TMP" serves as a temporary file and is
94 # automatically cleaned up.
95 try-run = $(shell set -e; \
97 TMPO=$(TMPOUT)/tmp.o; \
99 trap "rm -rf $(TMPOUT)" EXIT; \
100 if ($(1)) >/dev/null 2>&1; \
106 # Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
108 as-option = $(call try-run,\
109 $(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
112 # Usage: cflags-y += $(call as-instr,instr,option1,option2)
114 as-instr = $(call try-run,\
115 printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
118 # Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
119 __cc-option = $(call try-run,\
120 $(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
122 # Do not attempt to build with gcc plugins during cc-option tests.
123 # (And this uses delayed resolution so the flags will be up to date.)
124 CC_OPTION_CFLAGS = $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
127 # Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
129 cc-option = $(call __cc-option, $(CC),\
130 $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS),$(1),$(2))
133 # Usage: flag := $(call cc-option-yn,-march=winchip-c6)
134 cc-option-yn = $(call try-run,\
135 $(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
138 # Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
139 cc-disable-warning = $(call try-run,\
140 $(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
143 # Usage: EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
144 cc-ifversion = $(shell [ $(CONFIG_GCC_VERSION)0 $(1) $(2)000 ] && echo $(3) || echo $(4))
147 # Usage: KBUILD_LDFLAGS += $(call ld-option, -X, -Y)
148 ld-option = $(call try-run, $(LD) $(KBUILD_LDFLAGS) $(1) -v,$(1),$(2),$(3))
151 # Note this is mainly for HJ Lu's 3 number binutil versions
152 ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
155 # Usage: $(call ld-ifversion, -ge, 22252, y)
156 ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
161 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
163 # $(Q)$(MAKE) $(build)=dir
164 build := -f $(srctree)/scripts/Makefile.build obj
167 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
169 # $(Q)$(MAKE) $(dtbinst)=dir
170 dtbinst := -f $(srctree)/scripts/Makefile.dtbinst obj
173 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
175 # $(Q)$(MAKE) $(clean)=dir
176 clean := -f $(srctree)/scripts/Makefile.clean obj
179 # Short version is used, if $(quiet) equals `quiet_', otherwise full one.
180 echo-cmd = $(if $($(quiet)cmd_$(1)),\
181 echo ' $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
184 cmd = @set -e; $(echo-cmd) $(cmd_$(1))
187 # if_changed - execute command if any prerequisite is newer than
188 # target, or command line has changed
189 # if_changed_dep - as if_changed, but uses fixdep to reveal dependencies
190 # including used config symbols
191 # if_changed_rule - as if_changed but execute rule instead
192 # See Documentation/kbuild/makefiles.rst for more info
194 ifneq ($(KBUILD_NOCMDDEP),1)
195 # Check if both commands are the same including their order. Result is empty
196 # string if equal. User may override this check using make KBUILD_NOCMDDEP=1
197 cmd-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
198 $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
200 cmd-check = $(if $(strip $(cmd_$@)),,1)
203 # Replace >$< with >$$< to preserve $ when reloading the .cmd file
205 # Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
207 # Replace >'< with >'\''< to be able to enclose the whole string in '...'
208 # (needed for the shell)
209 make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
211 # Find any prerequisites that are newer than target or that do not exist.
212 # (This is not true for now; $? should contain any non-existent prerequisites,
213 # but it does not work as expected when .SECONDARY is present. This seems a bug
215 # PHONY targets skipped in both cases.
216 newer-prereqs = $(filter-out $(PHONY),$?)
218 # Execute command if command has changed or prerequisite(s) are updated.
219 if_changed = $(if $(newer-prereqs)$(cmd-check), \
221 printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
223 # Execute the command and also postprocess generated .d dependencies file.
224 if_changed_dep = $(if $(newer-prereqs)$(cmd-check),$(cmd_and_fixdep),@:)
228 scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).cmd;\
231 # Usage: $(call if_changed_rule,foo)
232 # Will check if $(cmd_foo) or any of the prerequisites changed,
233 # and if so will execute $(rule_foo).
234 if_changed_rule = $(if $(newer-prereqs)$(cmd-check),$(rule_$(1)),@:)
237 # why - tell why a target got built
238 # enabled by make V=2
239 # Output (listed in the order they are checked):
240 # (1) - due to target is PHONY
241 # (2) - due to target missing
242 # (3) - due to: file1.h file2.h
243 # (4) - due to command line change
244 # (5) - due to missing .cmd file
245 # (6) - due to target not in $(targets)
246 # (1) PHONY targets are always build
247 # (2) No target, so we better build it
248 # (3) Prerequisite is newer than target
249 # (4) The command line stored in the file named dir/.target.cmd
250 # differed from actual command line. This happens when compiler
252 # (5) No dir/.target.cmd file (used to store command line)
253 # (6) No dir/.target.cmd file and target not listed in $(targets)
254 # This is a good hint that there is a bug in the kbuild file
255 ifeq ($(KBUILD_VERBOSE),2)
257 $(if $(filter $@, $(PHONY)),- due to target is PHONY, \
258 $(if $(wildcard $@), \
259 $(if $(newer-prereqs),- due to: $(newer-prereqs), \
261 $(if $(cmd_$@),- due to command line change, \
262 $(if $(filter $@, $(targets)), \
263 - due to missing .cmd file, \
264 - due to $(notdir $@) not in $$(targets) \
269 - due to target missing \
273 echo-why = $(call escsq, $(strip $(why)))
276 ###############################################################################
278 # When a Kconfig string contains a filename, it is suitable for
279 # passing to shell commands. It is surrounded by double-quotes, and
280 # any double-quotes or backslashes within it are escaped by
283 # This is no use for dependencies or $(wildcard). We need to strip the
284 # surrounding quotes and the escaping from quotes and backslashes, and
285 # we *do* need to escape any spaces in the string. So, for example:
287 # Usage: $(eval $(call config_filename,FOO))
289 # Defines FOO_FILENAME based on the contents of the CONFIG_FOO option,
290 # transformed as described above to be suitable for use within the
293 # Also, if the filename is a relative filename and exists in the source
294 # tree but not the build tree, define FOO_SRCPREFIX as $(srctree)/ to
295 # be prefixed to *both* command invocation and dependencies.
297 # Note: We also print the filenames in the quiet_cmd_foo text, and
298 # perhaps ought to have a version specially escaped for that purpose.
299 # But it's only cosmetic, and $(patsubst "%",%,$(CONFIG_FOO)) is good
300 # enough. It'll strip the quotes in the common case where there's no
301 # space and it's a simple filename, and it'll retain the quotes when
302 # there's a space. There are some esoteric cases in which it'll print
303 # the wrong thing, but we don't really care. The actual dependencies
304 # and commands *do* get it right, with various combinations of single
305 # and double quotes, backslashes and spaces in the filenames.
307 ###############################################################################
309 define config_filename
310 ifneq ($$(CONFIG_$(1)),"")
311 $(1)_FILENAME := $$(subst \\,\,$$(subst \$$(quote),$$(quote),$$(subst $$(space_escape),\$$(space),$$(patsubst "%",%,$$(subst $$(space),$$(space_escape),$$(CONFIG_$(1)))))))
312 ifneq ($$(patsubst /%,%,$$(firstword $$($(1)_FILENAME))),$$(firstword $$($(1)_FILENAME)))
314 ifeq ($$(wildcard $$($(1)_FILENAME)),)
315 ifneq ($$(wildcard $$(srctree)/$$($(1)_FILENAME)),)
316 $(1)_SRCPREFIX := $(srctree)/
323 ###############################################################################
325 # delete partially updated (i.e. corrupted) files on error
328 # do not delete intermediate files automatically